<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
>

  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [leftTemplate]="leftTemplate"
                                [rightTemplate]="rightTemplate"
  ></solidify-detail-presentation>

  <ng-template #leftTemplate>

    <solidify-image-upload-wrapper-container [defaultIcon]="iconNameEnum.fundingAgencies"
                                             [resourceFileNameSpace]="adminFundingAgenciesActionNameSpace"
                                             [resourceFileState]="$any(adminFundingAgenciesState)"
                                             [uploadInstantly]="false"
                                             [isEditable]="(model | isNullOrUndefined) || editAvailable"
                                             (logoChange)="logoChange($event)"
    ></solidify-image-upload-wrapper-container>

  </ng-template>

  <ng-template #centerTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.acronym) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.acronym | translate}}</mat-label>
      <input (blur)="checkAvailable(formDefinition.acronym, fd)"
             [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput

      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.name) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.nameLabel | translate}}</mat-label>
      <input (blur)="checkAvailable(formDefinition.name, fd)"
             [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.description) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.description | translate}}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

  </ng-template>

  <ng-template #rightTemplate>

    <solidify-searchable-multi-select (navigate)="navigateToOrgUnit($event)"
                                      *ngIf="getFormControl(formDefinition.organizationalUnits) as fd"
                                      [formControl]="fd"
                                      [isWithLink]="true"
                                      [labelKey]="'name'"
                                      [placeholder]="labelTranslateEnum.clickHereToAddAnOrganizationalUnit | translate"
                                      [required]="formValidationHelper.hasRequiredField(fd)"
                                      [resourceNameSpace]="sharedOrganizationalUnitActionNameSpace"
                                      [sort]="sharedOrganizationalUnitSort"
                                      [state]="sharedOrganizationalUnitState"
                                      [title]="labelTranslateEnum.organizationalUnits | translate"
                                      [tooltipNavigateToTranslate]="labelTranslateEnum.seeOrganizationalUnitDetail | translate"
                                      [valueKey]="'resId'"
                                      [overlayComponent]="$any(organizationalUnitOverlayComponent)"
                                      aria-label="organizational unit"
                                      solidifyValidation
    >
    </solidify-searchable-multi-select>

    <solidify-url-input-navigator *ngIf="getFormControl(formDefinition.url) as fd"
                                  [formControl]="fd"
    >
    </solidify-url-input-navigator>

    <mat-form-field *ngIf="getFormControl(formDefinition.rorId) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.rorId | translate}}</mat-label>
      <input [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <dlcm-shared-identifiers *ngIf="model?.identifiers as identifiers"
                             [identifiers]="identifiers"
    ></dlcm-shared-identifiers>

  </ng-template>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
